//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////

#include "scene.h"

//////////////////////////////////////////////////////////////////////
// Tu je vsetko co sa kresli
int size=128;
float t,posuv=0.4f;
float delta_rot_x=0,delta_rot_y=45.f,delta_rot_z=0.f,rot_y=0,rot_x=30.f,rot_z;
int pocet_krokov=10;
int mod=0;


void DrawBlur(int pocet, float max_posun_tex_coord, float vysled_alpha)
{
	float alpha=0,alpha_delta,delta_coord=0.f;

	// vysled_alpha = vysldny jas je taky ako vykreslenie 1 textury s touto alpha
	// 0.5f*(1.f+pocet)*pocet = sucet od 1 po cislo pocet
	alpha_delta = vysled_alpha/( 0.5f*(1.f+pocet)*pocet );
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glBegin(GL_QUADS);
	for(int i=0; i<pocet; i++)
	{
		alpha += alpha_delta;
		glColor4f(1.f, 1.f, 1.f, alpha);

		glTexCoord2f(0+delta_coord, 0+delta_coord);
		glVertex2f(0, 0);

		glTexCoord2f(1-delta_coord, 0+delta_coord);
		glVertex2f(screen_x, 0);

		glTexCoord2f(1-delta_coord, 1-delta_coord);
		glVertex2f(screen_x, screen_y);

		glTexCoord2f(0+delta_coord, 1-delta_coord);
		glVertex2f(0, screen_y);
		delta_coord += max_posun_tex_coord/(float)pocet;
	}
	glEnd();
	glDisable(GL_BLEND);
}

void DrawHorizontalBlur(int pocet, float max_posun_tex_coord, float vysled_alpha)
{
	float alpha=0,alpha_delta,delta_coord=0.f;

	// vysled_alpha = vysldny jas je taky ako vykreslenie 1 textury s touto alpha
	// 0.5f*(1.f+pocet)*pocet = sucet od 1 po cislo pocet
	alpha_delta = vysled_alpha/( 0.5f*(1.f+pocet)*pocet );
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glBegin(GL_QUADS);
	for(int i=0; i<pocet; i++)
	{
		alpha += alpha_delta;
		glColor4f(1.f, 1.f, 1.f, alpha);

		glTexCoord2f(0+delta_coord, 0);
		glVertex2f(0, 0);

		glTexCoord2f(1-delta_coord, 0);
		glVertex2f(screen_x, 0);

		glTexCoord2f(1-delta_coord, 1);
		glVertex2f(screen_x, screen_y);

		glTexCoord2f(0+delta_coord, 1);
		glVertex2f(0, screen_y);
		delta_coord += max_posun_tex_coord/(float)pocet;
	}
	glEnd();
	glDisable(GL_BLEND);
}

void DrawVerticalBlur(int pocet, float max_posun_tex_coord, float vysled_alpha)
{
	float alpha=0,alpha_delta,delta_coord=0.f;

	// vysled_alpha = vysldny jas je taky ako vykreslenie 1 textury s touto alpha
	// 0.5f*(1.f+pocet)*pocet = sucet od 1 po cislo pocet
	alpha_delta = vysled_alpha/( 0.5f*(1.f+pocet)*pocet );
	
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glBegin(GL_QUADS);
	for(int i=0; i<pocet; i++)
	{
		alpha += alpha_delta;
		glColor4f(1.f, 1.f, 1.f, alpha);

		glTexCoord2f(0, 0+delta_coord);
		glVertex2f(0, 0);

		glTexCoord2f(1, 0+delta_coord);
		glVertex2f(screen_x, 0);

		glTexCoord2f(1, 1-delta_coord);
		glVertex2f(screen_x, screen_y);

		glTexCoord2f(0, 1-delta_coord);
		glVertex2f(0, screen_y);
		delta_coord += max_posun_tex_coord/(float)pocet;
	}
	glEnd();
	glDisable(GL_BLEND);
}

void scene::DrawGLScene()
{
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	{
		float _fps = fps;
		if(keys[VK_SHIFT])_fps *= 2.0f;
		if(keys['W'])delta_rot_x -= 30.0f/_fps;
		if(keys['S'])delta_rot_x += 30.0f/_fps;
		if(keys['A'])delta_rot_y -= 30.0f/_fps;
		if(keys['D'])delta_rot_y += 30.0f/_fps;
		if(keys['X'])delta_rot_z -= 30.0f/_fps;
		if(keys['E'])delta_rot_z += 30.0f/_fps;

		if(keys['W'] && keys['S']){delta_rot_x=0;}
		if(keys['A'] && keys['D']){delta_rot_y=0;}
		if(keys['E'] && keys['X']){delta_rot_z=0;}

		if(keys['R'])
		{
			rot_x = 0;
			rot_y = 0;
			rot_z = 0;
		}

		rot_x += delta_rot_x/fps;
		if(rot_x>360.f)rot_x-=360.f;
		else if(rot_x<0.f)rot_x+=360.f;
		rot_y += delta_rot_y/fps;
		if(rot_y>360.f)rot_y-=360.f;
		else if(rot_y<0.f)rot_y+=360.f;
		rot_z += delta_rot_z/fps;
		if(rot_y>360.f)rot_z-=360.f;
		else if(rot_z<0.f)rot_z+=360.f;
	}

	if(keys['P']){	ciary = !ciary;	keys['P']=0; }
		
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else	 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	if		(keys['1'])size=2;
	else if	(keys['2'])size=4;
	else if	(keys['3'])size=8;
	else if	(keys['4'])size=16;
	else if	(keys['5'])size=32;
	else if	(keys['6'])size=64;
	else if	(keys['7'])size=128;
	else if	(keys['8'])size=256;
	else if	(keys['9'])size=512;
	else if	(keys['0'])size=1;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	Prepni_do_3D();
	c->MoveWorld(fps);
	
	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }
	if(svetlo)glEnable(GL_LIGHTING);			// zapne svetlo

	glRotatef(rot_x,1,0,0);
	glRotatef(rot_y,0,1,0);
	glRotatef(rot_z,0,0,1);

	// render to texture
	glViewport(0, 0, size, size);

	if(keys['B'])
	{
		glColor3f(0,0,1.f);
		GLfloat mat_diffuse[]	= { 0.0f, 0.0f, 1.0f, 1.0f };
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE , mat_diffuse);
	}
	if(!keys['F'])_6kriz->Render();
	glColor3f(1,1,1);

	glBindTexture(GL_TEXTURE_2D, tex[0]);

	timer1.Reset();
//	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE, 0, 0, size, size, 0);
	if(!keys['F'])glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, size, size, 0);
	t = timer1.GetTime();

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
	glViewport(0, 0, screen_x, screen_y);
	// --------------------------------- //

	
	GLfloat mat_diffuse[]	= { 0.5f, 0.5f, 0.5f, 1.0f };
	glColor4f(0.5f, 0.5f, 0.5f, 1.0f);
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE , mat_diffuse);
	if(!keys['K']&&!keys['F'])_6kriz->Render();
	mat_diffuse[0] = 1.0f;
	mat_diffuse[1] = 1.0f;
	mat_diffuse[2] = 1.0f;
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE , mat_diffuse);
	glColor4f(1,1,1,1);

	Prepni_do_2D();
	glBindTexture(GL_TEXTURE_2D, tex[0]);
	switch(mod)
	{
	case 0:DrawBlur(pocet_krokov, posuv, 1.5f); break;
	case 1:DrawVerticalBlur(pocet_krokov, posuv, 1.5f); break;
	case 2:DrawHorizontalBlur(pocet_krokov, posuv, 1.5f); break;
	}
	
	if(keys[VK_SPACE])
	{
		mod++;
		if(mod==3) mod=0;
		keys[VK_SPACE]=0;
	}
	
	if(keys['M'])
	{
		posuv += 0.1f/fps;
	}
	else if(keys['N'])
	{
		posuv -= 0.1f/fps;;
	//	if(posuv<0)posuv=0;
	}

	if(keys[VK_ADD])
	{
		pocet_krokov++;
		keys[VK_ADD]=0;
	}
	else if(keys[VK_SUBTRACT])
	{
		pocet_krokov--;
		if(pocet_krokov<0)pocet_krokov=0;
		keys[VK_SUBTRACT]=0;
	}

	if(keys['F'])pocet_krokov=100000000/(screen_x*screen_y);

	if(keys['T'])
	{
		glBindTexture(GL_TEXTURE_2D, tex[0]);
		glLoadIdentity();
		glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex2i(0,0);
		glTexCoord2f(1.0f, 0.0f); glVertex2i(screen_x,0);
		glTexCoord2f(1.0f, 1.0f); glVertex2i(screen_x,screen_y);
		glTexCoord2f(0.0f, 1.0f); glVertex2i(0,screen_y);
		glEnd();
	}

	glColor4f(1,1,1,1);

	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);
	
	font0->Print(20,0,english ? "max shift:" : "max posuv:",0);
	gcvt( (double)posuv, 4, text);
	font0->Print(30,0,text,0);
	
	font0->Print(50,0,english? "count of layers:" : "pocet vrstiev:",0);
	itoa(pocet_krokov,text,10);
	font0->Print(english?66:64,0,text,0);

	gcvt( (double)t*1000.f, 4, text);
	strcat(text," ms");
	font0->Print(0,1,text,0);
	
	itoa(size,text,10);
	font0->Print(0,2,text,0);

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.6f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(80,100);
			glVertex2i(800,100);
			glVertex2i(800,555);
			glVertex2i(80,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Radial blur",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(15,i++,"+ on numeric. - increase count of layers",1);
			font0->Print(15,i++,"- on numeric. - decrease count of layers",1);
			font0->Print(15,i++,"space - change type of blur: radial, vertical, horizontal",1);
			font0->Print(15,i++,"M - increase maximal shift",1);
			font0->Print(15,i++,"N - decrease maximal shift",1);

			font0->Print(15,i++,"0,1,..,9 - set size of texture on 2^key",1);
			i++;
			font0->Print(15,i++,"P - on/off wire frame",1);
			font0->Print(15,i++,"L - on/off lighting",1);
			font0->Print(15,i++,"T - show texture",1);
			font0->Print(15,i++,"K - don't draw base",1);
			font0->Print(15,i++,"B - blue",1);
			i++;
			font0->Print(15,i++,"AD, WS, EX - rotate objecst in axis x, y, z",1);
			font0->Print_scale(15,i++,"A and simultaneously D - stop rotation x, similarly also for y,z axis",1,0.8f,1.f);
			i++;
			font0->Print(15,i++,"1. row - FPS, maximal shift, count of drawing layers",1);
			font0->Print(15,i++,"2. row - time for copying screen to texture",1);
			font0->Print(15,i++,"3. row - size of texture",1);
			font0->Print(15,i++,"count of layers - each layer is drawing to full screen",1);
			glColor3f(1,0.5f,0.5f);		
			font0->Print(15,i++,"F - set count of layers, so that this is valid:",1);
			font0->Print(25,i++,"fillrate = fps*100 MTexels/s",1);
		}
		else
		{
			font0->Print(15,i++,"Program: Radial blur",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(15,i++,"+ na numer. - zvacsuje pocet vrstiev",1);
			font0->Print(15,i++,"- na numer. - zmensuje pocet vrstiev",1);
			font0->Print(15,i++,"medzernik - meni typ bluru: radial, vertical, horizontal",1);
			font0->Print(15,i++,"M - zvacsuje maximalny posuv",1);
			font0->Print(15,i++,"N - zmensuje maximalny posuv",1);

			font0->Print(15,i++,"0,1,..,9 - nastavuje velkost textury na 2^klavesu",1);
			i++;
			font0->Print(15,i++,"P - zapne/vypne zobrazovanie ciar",1);
			font0->Print(15,i++,"L - zapne/vypne svetlo",1);
			font0->Print(15,i++,"T - zobrazy vytvorenu texturu",1);
			font0->Print(15,i++,"K - nekresli zaklad",1);
			font0->Print(15,i++,"B - modra, blue",1);
			i++;
			font0->Print(15,i++,"AD, WS, EX - rotuje objekt podla smerov x, y, z",1);
			font0->Print(15,i++,"A a zaroven D - stop rotacia x, podobne aj pre osi y,z",1);
			i++;
			font0->Print(15,i++,"1. riadok - FPS, maximalny posuv, pocet kreslenych vrstiev",1);
			font0->Print(15,i++,"2. riadok - cas potrebny na skopirovanie do textury",1);
			font0->Print(15,i++,"3. riadok - velkost textury",1);
			font0->Print(15,i++,"pocet vrtiev - kazda vrstva sa kresli na celu obrazovku",1);
			glColor3f(1,0.5f,0.5f);		
			font0->Print(15,i++,"F - nastavy pocet vrstiev tak ze plati:",1);
			font0->Print(25,i++,"fillrate = fps*100 MTexels/s",1);
		}
		glColor3f(1,1,1);
		font0->Print(15,i++,"H - help",1);
	}
	font0->End();
	if(keys['S']){	SaveScreen();	keys['S']=0;}		// ulozenie obrazovky do raw subora
}
